/*****************************************************************************
**																			**
**	 Project Name: 	LCD											**	
**																			**
******************************************************************************

(C) Copyright 2005 - Analog Devices, Inc.  All rights reserved.

File Name:		Interrupt_Init.c

Date Modified:	5/1/05		CL		Rev 1.0

Software:       VisualDSP++3.5

Hardware:		ADSP-BF561 EZ-KIT Lite

Special Connections:  None

Purpose:		This file sets up the interrupts.
				
******************************************************************************/



#include "main.h"

/********************************************************************************/
/***** setup of interrupts on core A										*****/
/********************************************************************************/

void Init_Interrupts_A(void)
{ 	
	register_handler(ik_ivg8, PPI0_RxIsr);		// assign ISR to interrupt vector

	*pSICA_IAR1 = Peripheral_IVG(11,8);			// assign interrupt channel 11 (DMA1_0) to IVG8

	*pILAT |= EVT_IVG8;							// clear pending IVG8 interrupts
	ssync();
	*pSICA_IMASK0 |= SIC_MASK(11);
	ssync();
	*pSICA_IWR1 |= 0x00200000;
	ssync();


}
