/*****************************************************************************
**																			**
**	 Project Name: 	LCD											**	
**																			**
******************************************************************************

(C) Copyright 2005 - Analog Devices, Inc.  All rights reserved.

File Name:		Interrupt_Service.c

Date Modified:	5/1/05		CL		Rev 1.0

Software:       VisualDSP++3.5

Hardware:		ADSP-BF561 EZ-KIT Lite

Special Connections:  None

Purpose:		This file contains the interrupt service routine.
				
******************************************************************************/



#include "main.h"
#include "sysreg.h"

extern volatile short descript_buf_tx[];
extern volatile short frame_counter;
/********************************************************************************/
/***** Defines the interrupt service routines for CoreB				*****/
/********************************************************************************/
volatile short *p = descript_buf_tx;
volatile char i;

EX_INTERRUPT_HANDLER(PPI_TxIsr) {

	*pDMA1_1_IRQ_STATUS |= DMA_DONE;		// acknowledge interrupt
	ssync();

	frame_counter++;
	ssync();
	
	if(frame_counter == 1){
		Decimate_h(sFrame0, Decimate0_h);
		_YCbCrtoRGB(Decimate0_h, dFrame0, 76800);
		*(p) = (unsigned short) ((int)(p)+(int)(8)) & 0xffff;
		*(p+4) = (unsigned short) ((int)(p+4))  & 0xffff;
		ssync();
	}
	
	if(frame_counter == 2){
		Decimate_h(sFrame1, Decimate1_h);
		_YCbCrtoRGB(Decimate1_h, dFrame1, 76800);
		*(p+4) = (unsigned short) ((int)(p+4)-(int)(8)) & 0xffff;
		*(p) = (unsigned short) ((int)(p))  & 0xffff;
		frame_counter = 0;
		ssync();
	}
	
	
		
}



